#ifndef SYSTEMEVENTS_EVENTS_HPP_INCLUDED
#define SYSTEMEVENTS_EVENTS_HPP_INCLUDED

#if _MSC_VER > 1020
#  pragma once
#endif // _MSC_VER

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
//  events.hpp
//  This is a part of the systemevents source code.
//
//  Copyright (C) 2003 ilmcuts.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

#include "common.hpp"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// Events Enum
//
enum EventIDs
{
    // LS Events
    EVENT_START,
    EVENT_QUIT,
    EVENT_REFRESH,

    // Windows Events
    EVENT_DISPCHANGE,
    EVENT_FONTCHANGE,
    EVENT_SCREENSAVER_ON,
    EVENT_SCREENSAVER_OFF,
    EVENT_HIBERNATE,
    EVENT_RESUME,
    EVENT_SHUTDOWN,
    EVENT_LOGOFF,

    // Shell Hook Events
    EVENT_FULLSCREEN_ON,
    EVENT_FULLSCREEN_OFF
};


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// typedefs
//
typedef std::multimap<EventIDs, std::string> EventMap;


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// template NamedValue
//
template <class T> struct NamedValue
{
    const char* pszName;
    T tValue;
};


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// externs/function prototypes
//
extern const NamedValue<EventIDs> g_EventTable[];
extern const UINT g_stEventTableItems;
extern EventMap g_EventMap;

void ExecuteEvent(EventIDs uIdentifier);
LRESULT WINAPI WindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);


#endif // !defined(SYSTEMEVENTS_EVENTS_HPP_INCLUDED)
